﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace DataChart_CategoryDateTimeInterval
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            DataContext = DataItem.GetData(6, 1000, 2000);
           
                
            
        }

        private void xAxis_Loaded(object sender, RoutedEventArgs e)
        {
            
            (sender as CategoryDateTimeXAxis).Interval = new TimeSpan(31, 0, 0, 0, 0);
        }
    }

    public class DataItem : INotifyPropertyChanged
    {
        private int value;
        private DateTime label;

        public DateTime Date
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Date");
            }
        }

        public double DoubleDate
        {
            get { return label.ToOADate(); }
            set
            {
                label = DateTime.FromOADate(value);
                PropChanged("DoubleDate");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<DataItem> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<DataItem> data = new ObservableCollection<DataItem>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new DataItem
                {
                    Date = DateTime.Now.AddMonths(-1).AddDays(i * 31),
                    Value = r.Next(rangeStart, rangeEnd),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
